task fastqc {

  File Fq
  File path
  command {
	 fastqc --extract ${Fq} -o ${path}

  }
  runtime{
     docker:"fastq:latest"
     cpu:"1"
     memory:"5GB"
  
  }
}


task Q30 {

  File Fq
  String side	
  String sampleName

  command {
	 python2.7 /Bio/q30.py  ${Fq} > ${sampleName}_${side}.Q30.stat

  }
  runtime{
     docker:"rendong-rawqc:latest"
     cpu:"1"
     memory:"5GB"
  
  }
}

task QC {

  File Fq
  String side	
  String sampleName

  command {
	/Bio/kseq_fastq_base ${Fq} >${sampleName}_${side}.stat
  }
  runtime{
     docker:"rendong-rawqc:latest"
     cpu:"1"
     memory:"5GB"
  
  }
}

task mkdir {

  String sampleName

  command {
	mkdir ${sampleName}
  }
  output {
        File path = "${sampleName}"
  }
}

task name {

  String sampleName

  command {
	basename ${sampleName} >name.txt
  }
  output {
        String value =read_string("name.txt")
  }
}

task fastp {

  File Fq1
  File Fq2	
  String sampleName

  command {
	fastp -i ${Fq1} -I ${Fq2} -o ${sampleName}_R1.fastq -O ${sampleName}_R2.fastq -n 15 -q 15 -u 40 -l 50  -G -j ${sampleName}.json -h ${sampleName}.html
  }
  output {
        File R1 ="${sampleName}_R1.fastq"
        File R2 ="${sampleName}_R2.fastq"
        File json ="${sampleName}.json"
        File html ="${sampleName}.html"
  }
  runtime{
     docker:"fastp:latest"
     cpu:"12"
     memory:"20GB"
  
  }
}

task qc_stat {

  Array[File] json
  String qc_result

  command {
	perl /opt/fq_stat2.pl -i ${sep=',' json} -od  ${qc_result}
  }
  output {
        File result ="${qc_result}"
	File stat="${qc_result}/cleandata_stat.txt"
  }
  runtime{
     docker:"r_perl:latest"
     cpu:"1"
     memory:"2GB"
  
  }
}
